#include <windows.h>
#include <stdio.h>

void dump (char *begin, char *ptr) {
    printf("%s: %02hx %02hx %02hx %02hx %02hx %02hx %02hx %02hx %02hx %02hx %02hx %02hx %02hx %02hx %02hx %02hx\n",
            begin,
            ptr[0],  ptr[1], ptr[2], ptr[3], ptr[4], ptr[5], ptr[6],
            ptr[7],  ptr[8], ptr[9], ptr[10], ptr[11], ptr[12], ptr[13],
            ptr[14], ptr[15]);

}
BOOL CALLBACK AboutDialogProc(HWND hwndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
    int len = 512;
    WCHAR text[512];
    char *ptr;
    switch (uMsg)
    {
        case WM_INITDIALOG:
            ptr = (char*)&text;
            /* Print our "unicode" string */
            RtlZeroMemory(text, len * sizeof(WCHAR));
            SetWindowTextW(hwndDlg, L"This is a test");
            InternalGetWindowText(hwndDlg, text, len + 1);
            dump("SetWindowTextW: ", ptr);

            /* Now the ANSI string */
            RtlZeroMemory(text, len * sizeof(WCHAR));
            SetWindowTextA(hwndDlg, (char*)L"Everything works");
            InternalGetWindowText(hwndDlg, text, len + 1);
            dump("SetWindowTextA: ", ptr);
            return TRUE;
        case WM_COMMAND:
            switch(LOWORD(wParam)) {
                case 1011:
                    return TRUE;
            }
            break;
        case WM_CLOSE:
            ExitProcess(0);
        default:
            return FALSE;
    }
}

typedef void(*PINITCOMMONCONTROLS)(void);

    int WINAPI
WinMain(HINSTANCE hInst,
        HINSTANCE hPrevInst,
        LPSTR lpCmdLine,
        int nCmdShow)
{
    HANDLE hComctl;
    PINITCOMMONCONTROLS pCtl;
#ifdef _ON_WINDOWS
    hComctl = LoadLibrary("./comctl32.dll");
    //pCtl = (PINITCOMMONCONTROLS)GetProcAddress(hComctl, "InitCommonControls");
    //pCtl();
#else
    hComctl = LoadLibrary("comctl32.dll");
#endif
    DialogBoxParam(
            hInst,
            "WUT",
            NULL,
            AboutDialogProc,
            0);
    return 0;
}

